<?php

//　imgスレをxml形式に整形するスクリプト
class ImgScraper
{

	var $results = "";
	
	function translate($url){
		$disp = "";
		$src = "";
		
		//スレを取得
		$src = file_get_contents($url);
		$src = mb_convert_encoding($src, "UTF-8", "SJIS");
		$disp .="<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
		$disp .= "<feed>\n";
		
		if($src != ""){

			$disp .= "<url>".$url."</url>\n";
			
			//レスを抽出
			preg_match_all("/\<table border=0\>.+\n.+\<\/table\>/",$src,$coms);
			
			//imgにいる人数を抽出
			preg_match("/現在([0-9]+)人くらいが見てます/",$src,$visitor);
			
			$disp .= "<visitor>".$visitor[1]."</visitor>\n";

			//スレ画像のファイル名・スレ本文を抽出
			preg_match("/([0-9]{13})(\.jpg|\.gif|\.png).+\<\/blockquote\>/s",$src,$tpict);
			
			//スレが消える時間を抽出
			preg_match("/([0-9]{2}):([0-9]{2})頃消えます/",$tpict[0],$del_time);
			
			$disp .= "<vanish_time>".$del_time[1].":".$del_time[2]."</vanish_time>\n";

			//本文のメール欄の内容を抽出
			preg_match("/\<a href=\"mailto:(.+)\"\"\>/",$tpict[0],$ml);
			if($ml[0] != ""){
				$ml[0] = "<mail>".$ml[1]."</mail>\n";
			}else{
				$ml[0] = "<mail></mail>\n";
			}
			
			//スレ画像のファイル名からアドレス(フルパス)を作成

			$tp2 = "http://feb.2chan.net/img/b/src/".$tpict[1].$tpict[2];
			$disp .= "<picture>".$tp2."</picture>\n";
			
			//スレの立った時間・番号を抽出
			preg_match("/([0-9]{2}\/[0-9]{2}\/[0-9]{2})\((.+)\)([0-9]{2}:[0-9]{2}:[0-9]{2}).+No\.([0-9]{8})/",$tpict[0],$hd);
			
			//レスの内容を抽出
			preg_match("/\<blockquote\>(.+)\<\/blockquote\>/",$tpict[0],$cm);
			
			//レスの内容から <br>を\nに置換
			$cm[1] = str_replace("<br>","\n",$cm[1]);
			
			//レスの内容からタグを除去
			$cm[1] = strip_tags($cm[1]);
			
			
			$disp .= "<res>\n";
			$disp .= "<date>".$hd[1]."</date>\n";
			$disp .= "<week>".$hd[2]."</week>\n";
			$disp .= "<time>".$hd[3]."</time>\n";
			$disp .= "<number>".$hd[4]."</number>\n";
			$disp .= $ml[0];
			$disp .= "<comment>".$cm[1]."</comment>\n";
			$disp .= "</res>\n";
			
			
			//１レス目以降のレスを扱う
			foreach($coms[0] as $val){
				
				//メール欄の内容を抽出
				preg_match("/\<a href=\"mailto:(.+)\"\"\>/",$val,$ml);
				
				if($ml[0] != ""){
					$ml[0] = "<mail>".$ml[1]."</mail>\n";
				}else{
					$ml[0] = "<mail></mail>\n";
				}
				
				//レスされた時間・番号を抽出
				preg_match("/([0-9]{2}\/[0-9]{2}\/[0-9]{2})\((.+)\)([0-9]{2}:[0-9]{2}:[0-9]{2}).+No\.([0-9]{8})/",$val,$hd);
				
				//レスの内容を抽出
				preg_match("/\<blockquote\>(.+)\<\/blockquote\>/",$val,$cm);
				
				//レスの内容から <br>を\nに置換
				$cm[1] = str_replace("<br>","\n",$cm[1]);
				
				//レスの内容からタグを除去
				$cm[1] = strip_tags($cm[1]);
				
				
				//１レス分の要素の記述を開始
				$disp .= "<res>\n";
				//レスされた日付
				$disp .= "<date>".$hd[1]."</date>\n";
				//レスされた曜日
				$disp .= "<week>".$hd[2]."</week>\n";
				//レスされた時間
				$disp .= "<time>".$hd[3]."</time>\n";
				//レス番号
				$disp .= "<number>".$hd[4]."</number>\n";
				//レスのメール欄の内容
				$disp .= $ml[0];
				//レスの本文
				$disp .= "<comment>".$cm[1]."</comment>\n";
				//ここで記述終了
				$disp .= "</res>\n";
				
			}
		
		}else{
		}
		$disp .= "</feed>";
		
		$this->results = $disp;
		
		return true;
	}

}